//
//  FlutterSurfaceView.m
//  linkv_rtc
//
//  Created by Wing on 2020/7/22.
//

#import "FlutterSurfaceView.h"
#import <LinkV/LinkV.h>

@interface FlutterSurfaceView ()

@property (nonatomic, strong) LVRTCDisplayView *displayView;

@end

@implementation FlutterSurfaceView

- (instancetype)initWithFrame:(CGRect)frame viewIdentifier:(int64_t)viewId arguments:(id)args {
    if (self = [super init]) {
        
        self.displayView = [LVRTCDisplayView new];
        self.displayView.viewContentMode = LVViewContentModeScaleAspectFill;
        
        BOOL isMaster = NO;
        
        if ([args isKindOfClass:[NSDictionary class]]) {
            NSDictionary *dict = args;
            isMaster = [dict[@"isMaster"] boolValue];
            NSString *uid = dict[@"uid"];
            
            self.displayView.uid = uid;
            self.displayView.isLocal = isMaster;
        }
        
        if (isMaster) {
            [[LVRTCEngine sharedInstance] startCapture];
        }
        
        [[LVRTCEngine sharedInstance] addDisplayView:self.displayView];
    }
    
    return self;
}

- (UIView *)view {
    return self.displayView;
}

- (void)dealloc {
    NSLog(@"[Wing] %@ dealloc🍀🍀🍀🍀", self);
    
    if (self.displayView) {
        [[LVRTCEngine sharedInstance] removeDisplayView:self.displayView];
    }
}


@end
